unit VPMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, Spin, ExtCtrls, VPUtils;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    edVPCode: TEdit;
    dtpkrSTime: TDateTimePicker;
    Label2: TLabel;
    Label3: TLabel;
    btnEncode: TButton;
    btnDecode: TButton;
    Label4: TLabel;
    dtpkrETime: TDateTimePicker;
    edDuration: TEdit;
    Label5: TLabel;
    spnedChannel: TSpinEdit;
    dtpkrSDate: TDateTimePicker;
    Label6: TLabel;
    Bevel1: TBevel;
    procedure btnDecodeClick(Sender: TObject);
    procedure btnEncodeClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;


var
  Form1: TForm1;
  Schedule: TSchedule;

implementation

{$R *.DFM}

procedure TForm1.btnDecodeClick(Sender: TObject);
var
   VPCode: LongInt;
begin
   // Get user specified VideoPlus code
   if length(edVPCode.Text) = 0 then
      raise Exception.Create('You must provide a VideoPlus code to decode !');
   try
      VPCode := StrToInt(edVPCode.Text);
   except
      raise Exception.Create('Invalid VideoPlus code (must be numeric)');
   end;
   // Decode VideoPlus code using todays date as a reference
   Decode(VPCode,Date,Schedule);
   // Show decoded schedule
   dtpkrSDate.Date := Schedule.SDate;
   dtpkrSTime.Time := Schedule.STime;
   dtpkrETime.Time := Schedule.ETime;
   edDuration.Text := IntToStr(Schedule.Durn);
   spnedChannel.Value := Schedule.Channel;
end;

procedure TForm1.btnEncodeClick(Sender: TObject);
var
   VPCode: LongInt;
begin
   // Get user specified programme schedule
   Schedule.SDate   := dtpkrSDate.Date;
   Schedule.STime   := dtpkrSTime.Time;
   Schedule.ETime   := dtpkrETime.Time;
   Schedule.Durn    := StrToInt(edDuration.Text);
   Schedule.Channel := spnedChannel.Value;
   // Decode VideoPlus code using todays date as a reference
   VPCode := Encode(Date,Schedule);
   // Show encoded VideoPlus code
   edVPCode.Text := IntToStr(VPCode);
end;




procedure TForm1.FormCreate(Sender: TObject);
begin
     dtpkrSDate.Date := Date;
     dtpkrSTime.Time := Time;
     edDuration.Text := '30';
     dtpkrETime.Time := dtpkrSTime.Time + (StrToInt(edDuration.Text)/(24*60));
end;

end.
